/*----- PROTECTED REGION ID(AccessControlClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        AccessControlClass.h
//
// description : Include for the AccessControlClass root class.
//               This class is the singleton class for.
//               the AccessControl device class..
//               It contains all properties and methods which the .
//               AccessControl requires only once e.g. the commands.
//
// project :     cess Control abstract class.
//
//
// Copyright (C) :      2004,2005,2006,2007,2008,2009,2010,2011
//						European Synchrotron Radiation Facility
//                      BP 220, Grenoble 38043
//                      FRANCE
//
// This file is part of Tango.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
// $Author: pascal_verdier $
//
// $Revision: 26622 $
// $Date: 2014-10-02 14:26:29 +0200 (Thu, 02 Oct 2014) $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source$
// $Log$
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef ACCESSCONTROLCLASS_H
#define ACCESSCONTROLCLASS_H

#include <tango.h>
#include <AccessControl.h>

/*----- PROTECTED REGION END -----*/	//	AccessControlClass.h


namespace AccessControl_ns
{
/*----- PROTECTED REGION ID(AccessControlClass::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AccessControlClass::classes for dynamic creation

//=========================================
//	Define classes for commands
//=========================================

/**
 *	The AccessControlClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AccessControlClass : public Tango::DeviceClass
#else
class AccessControlClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AccessControlClass::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AccessControlClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AccessControlClass *init(const char *);
		static AccessControlClass *instance();
		~AccessControlClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AccessControlClass(string &);
		static AccessControlClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
};

}	//	End of namespace

#endif   //	AccessControl_H
